<?php
class solicitudesModel {

	public $db;

	function __construct() {
		$this->db=adoNewConnection(DB_TIPO);$this->db->debug=DB_DEBUG;$this->db->SetFetchMode(ADODB_FETCH_ASSOC);
		$this->db->connect(DB_SERVER,DB_USER,DB_CLAVE,DB_DB);
	}

	function __destruct() {$this->db->close();}

	public function cantidad(){
		$sql="SELECT count(solicitudes.id) as son FROM solicitudes";
		$son=$this->db->Execute($sql);
		return $son->fields["son"];
	}

	public function activos(){
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre
			FROM solicitudes
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
			WHERE solicitudes.estado<3
		";
		return $this->db->Execute($sql);
	}

	public function inactivos(){
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre
			FROM solicitudes
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
			WHERE solicitudes.estado>2
		";
		return $this->db->Execute($sql);
	}

	public function listar(){
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre, clientes.operario_id as clientes_operario_id, clientes.operarios
			FROM solicitudes
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
		";
		return $this->db->Execute($sql);
	}

	public function ver($id){
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre
			FROM solicitudes 
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
			WHERE solicitudes.id = ".$id;
		return $this->db->Execute($sql);
	}

	public function filtrar($llega){
		$where="";
		if(isset($llega["tipo"]) && $llega["tipo"]!=0 && $llega["tipo"]!="")
			$where.="solicitudes.tipo = ".$llega["tipo"]." AND ";
 		if(isset($llega["titulo"]) && $llega["titulo"]!="")
			$where.="solicitudes.titulo REGEXP '".$llega["titulo"]."' AND ";
 		if(isset($llega["categorioa"]) && $llega["categorioa"]!=0 && $llega["categorioa"]!="")
			$where.="solicitudes.categorioa = ".$llega["categorioa"]." AND ";
 		if(isset($llega["prioridad"]) && $llega["prioridad"]!=0 && $llega["prioridad"]!="")
			$where.="solicitudes.prioridad = ".$llega["prioridad"]." AND ";
 		if(isset($llega["ubicacion"]) && $llega["ubicacion"]!=0 && $llega["ubicacion"]!="")
			$where.="solicitudes.ubicacion = ".$llega["ubicacion"]." AND ";
 		if(isset($llega["operario_id"]) && $llega["operario_id"]!=0 && $llega["operario_id"]!="")
			$where.="solicitudes.operario_id = ".$llega["operario_id"]." AND ";
 		if(isset($llega["estado"]) && $llega["estado"]!=-1)
			$where.="solicitudes.estado = ".$llega["estado"]." AND ";
 		if(isset($llega["cliente_id"]) && $llega["cliente_id"]!=0 && $llega["cliente_id"]!="")
			$where.="clientes.id = ".$llega["cliente_id"]." AND ";
 		if(isset($llega["usuario_id"]) && $llega["usuario_id"]!=0 && $llega["usuario_id"]!="")
			$where.="solicitudes.usuario_id = ".$llega["usuario_id"]." AND ";
 
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre
			FROM solicitudes
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
			WHERE ".$where." 1
		";
		return $this->db->Execute($sql);
	}

	public function agregando($entra){
		if($this->db->AutoExecute("solicitudes",$entra,"INSERT")==false){return 0;}else{return $this->db->INSERT_ID();}
	}

	public function editar($id){
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre
			FROM solicitudes 
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
			WHERE solicitudes.id = ".$id;
		return $this->db->Execute($sql);
	}

	public function editando($id,$entra){
		if($this->db->AutoExecute("solicitudes",$entra,"UPDATE","id=".$id)==false){return 0;}else{return $id;}
	}

	public function eliminar($id){
		return $this->db->Execute("DELETE FROM solicitudes WHERE id=".$id);
	}

	public function limite($uid){
		$sql="
			SELECT count(solicitudes.id) as son
			FROM solicitudes
			WHERE estado<3 AND usuario_id = ".$uid;
		$son=$this->db->Execute($sql);
		return $son->fields["son"];
	}

	public function xcliente($cid){
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre
			FROM solicitudes
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
			WHERE clientes.id = ".$cid;
		return $this->db->Execute($sql);
	}

	public function xusuario($cid){
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre
			FROM solicitudes
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
			WHERE usuario_id = ".$cid;
		return $this->db->Execute($sql);
	}

	public function activosxcliente($cid){
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre
			FROM solicitudes
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
			WHERE solicitudes.estado<3 AND clientes.id = ".$cid;
		return $this->db->Execute($sql);
	}

	public function activosxusuario($cid){
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre
			FROM solicitudes
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
			WHERE solicitudes.estado<3 AND usuario_id = ".$cid;
		return $this->db->Execute($sql);
	}

	public function finalizadoxcliente($cid){
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre
			FROM solicitudes
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
			WHERE solicitudes.estado>2 AND clientes.id = ".$cid;
		return $this->db->Execute($sql);
	}

	public function finalizadoxusuario($cid){
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre
			FROM solicitudes
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
			WHERE solicitudes.estado>2 AND usuario_id = ".$cid;
		return $this->db->Execute($sql);
	}

	public function xoperario($oid){
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre
			FROM solicitudes
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
			WHERE solicitudes.operario_id = ".$oid;
		return $this->db->Execute($sql);
	}

	public function xoperarioactivo($oid){
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre
			FROM solicitudes
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
			WHERE solicitudes.estado=2 AND solicitudes.operario_id = ".$oid;
		return $this->db->Execute($sql);
	}

	public function xofiltrar($llega){
		$where="";
		if(isset($llega["tipo"]) && $llega["tipo"]!=0 && $llega["tipo"]!="")
			$where.="solicitudes.tipo = ".$llega["tipo"]." AND ";
 		if(isset($llega["titulo"]) && $llega["titulo"]!="")
			$where.="solicitudes.titulo REGEXP '".$llega["titulo"]."' AND ";
 		if(isset($llega["prioridad"]) && $llega["prioridad"]!=0 && $llega["prioridad"]!="")
			$where.="solicitudes.prioridad = ".$llega["prioridad"]." AND ";
 		if(isset($llega["estado"]) && $llega["estado"]!=-1)
			$where.="solicitudes.estado = ".$llega["estado"]." AND ";
		$where.="solicitudes.operario_id = ".$llega["operario_id"];
		$sql="
			SELECT solicitudes.*, usuarios.nombre as usuarios_nombre, operarios.nombre as operarios_nombre, clientes.nombre as clientes_nombre
			FROM solicitudes
			LEFT JOIN usuarios ON solicitudes.usuario_id=usuarios.id
			LEFT JOIN operarios ON solicitudes.operario_id=operarios.id
			LEFT JOIN clientes ON usuarios.cliente_id=clientes.id
			WHERE ".$where."
			";
		return $this->db->Execute($sql);
	}


}
